about summary refs log tree commit diff
path: root/pkgs/build-support/setup-hooks
diff options
context:
space:
mode:
authorJohn Ericson <John.Ericson@Obsidian.Systems>2020-04-17 18:40:51 -0400
committerJohn Ericson <John.Ericson@Obsidian.Systems>2020-04-17 18:40:51 -0400
commit33c2a76c5e1dac06d2963ad626d1083ed4b96f06 (patch)
tree90e5ce60f3d7ea83f41f54c86971e19aae6b3594 /pkgs/build-support/setup-hooks
parentd1009f4d99dbb6600f08ab0ef214806acc675670 (diff)
parentcdfda4b455d0d904428fd157fba323f131fe8f6f (diff)
downloadnixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar.gz
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar.bz2
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar.lz
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar.xz
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.tar.zst
nixlib-33c2a76c5e1dac06d2963ad626d1083ed4b96f06.zip
Merge remote-tracking branch 'upstream/master' into staging
Diffstat (limited to 'pkgs/build-support/setup-hooks')
-rw-r--r--pkgs/build-support/setup-hooks/audit-blas.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/pkgs/build-support/setup-hooks/audit-blas.sh b/pkgs/build-support/setup-hooks/audit-blas.sh
new file mode 100644
index 000000000000..6a40073fb234
--- /dev/null
+++ b/pkgs/build-support/setup-hooks/audit-blas.sh
@@ -0,0 +1,37 @@
+# Ensure that we are always linking against “libblas.so.3” and
+# “liblapack.so.3”.
+
+auditBlas() {
+    local dir="$prefix"
+    [ -e "$dir" ] || return 0
+
+    local i
+    while IFS= read -r -d $'\0' i; do
+        if ! isELF "$i"; then continue; fi
+
+        if $OBJDUMP -p "$i" | grep 'NEEDED' | awk '{ print $2; }' | grep -q '\(libmkl_rt.so\|libopenblas.so.0\)'; then
+            echo "$i refers to a specific implementation of BLAS or LAPACK."
+            echo "This prevents users from switching BLAS/LAPACK implementations."
+            echo "Add \`blas' or \`lapack' to buildInputs instead of \`mkl' or \`openblas'."
+            exit 1
+        fi
+
+        (IFS=:
+         for dir in "$(patchelf --print-rpath "$i")"; do
+             if [ -f "$dir/libblas.so.3" ] || [ -f "$dir/libblas.so" ]; then
+                 if [ "$dir" != "@blas@/lib" ]; then
+                     echo "$dir is not allowed to contain a library named libblas.so.3"
+                     exit 1
+                 fi
+             fi
+             if [ -f "$dir/liblapack.so.3" ] || [ -f "$dir/liblapack.so" ]; then
+                 if [ "$dir" != "@lapack@/lib" ]; then
+                     echo "$dir is not allowed to contain a library named liblapack.so.3"
+                     exit 1
+                 fi
+             fi
+         done)
+    done < <(find "$dir" -type f -print0)
+}
+
+fixupOutputHooks+=(auditBlas)